'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _jsx = function () { var REACT_ELEMENT_TYPE = typeof Symbol === "function" && Symbol.for && Symbol.for("react.element") || 0xeac7; return function createRawReactElement(type, props, key, children) { var defaultProps = type && type.defaultProps; var childrenLength = arguments.length - 3; if (!props && childrenLength !== 0) { props = {}; } if (props && defaultProps) { for (var propName in defaultProps) { if (props[propName] === void 0) { props[propName] = defaultProps[propName]; } } } else if (!props) { props = defaultProps || {}; } if (childrenLength === 1) { props.children = children; } else if (childrenLength > 1) { var childArray = Array(childrenLength); for (var i = 0; i < childrenLength; i++) { childArray[i] = arguments[i + 3]; } props.children = childArray; } return { $$typeof: REACT_ELEMENT_TYPE, type: type, key: key === undefined ? null : '' + key, ref: null, props: props, _owner: null }; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _reactors = require('reactors');

var _compact = require('lodash/compact');

var _compact2 = _interopRequireDefault(_compact);

var _findIndex = require('lodash/findIndex');

var _findIndex2 = _interopRequireDefault(_findIndex);

var _first = require('lodash/first');

var _first2 = _interopRequireDefault(_first);

var _get = require('lodash/get');

var _get2 = _interopRequireDefault(_get);

var _includes = require('lodash/includes');

var _includes2 = _interopRequireDefault(_includes);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

var _pick = require('lodash/pick');

var _pick2 = _interopRequireDefault(_pick);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _Route = require('./Route');

var _Route2 = _interopRequireDefault(_Route);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ReactorsRouter = function (_Component) {
  _inherits(ReactorsRouter, _Component);

  function ReactorsRouter(props) {
    _classCallCheck(this, ReactorsRouter);

    var _this = _possibleConstructorReturn(this, (ReactorsRouter.__proto__ || Object.getPrototypeOf(ReactorsRouter)).call(this, props));

    _initialiseProps.call(_this);

    _this.name = props.name;
    ReactorsRouter.routers[_this.name] = _this;
    return _this;
  }

  return ReactorsRouter;
}(_react.Component);

ReactorsRouter.routers = {};
ReactorsRouter.Route = _Route2.default;

ReactorsRouter.get = function (name) {
  return ReactorsRouter.routers[name];
};

ReactorsRouter.getRoute = function (routeName, routes, mounted) {
  var current = void 0;
  var currentIndex = void 0;
  routes.forEach(function (route, index) {
    if (route.props.name === routeName && (0, _includes2.default)(mounted, route.props.name)) {
      current = route;
      currentIndex = index;
    }
  });
  return _extends({}, current, { index: currentIndex });
};

ReactorsRouter.makeState = function (props) {
  var routes = _react2.default.Children.toArray(props.children);
  var currentRoute = ReactorsRouter.getRoute(props.initial, routes);
  var state = { routes: routes };
  if (currentRoute) {
    state.current = currentRoute.name;
  } else {
    state.current = (0, _first2.default)(routes).name;
  }
  return state;
};

var _initialiseProps = function _initialiseProps() {
  var _this2 = this;

  this.state = ReactorsRouter.makeState(this.props);
  this.mounted = (0, _compact2.default)([this.props.initial || (0, _get2.default)((0, _first2.default)(_react2.default.Children.toArray(this.props.children)), 'props.name')]);

  this.componentWillReceiveProps = function (nextProps) {
    var nextState = {};
    var prevChildren = _react2.default.Children.toArray(_this2.props.children);
    var nextChildren = _react2.default.Children.toArray(nextProps.children);
    if (prevChildren.length !== nextChildren.length) {
      nextState = ReactorsRouter.makeState(nextProps);
    }
    _this2.setState(nextState, function () {
      var fullWidth = _this2.getFullWidth();
      var node = _reactDom2.default.findDOMNode(_this2);
      node.querySelector('.reactors-router-animated').style.width = fullWidth + 'px';
    });
  };

  this.componentDidUpdate = function (prevProps, prevState) {
    if (prevState.current !== _this2.state.current) {
      var routes = _react2.default.Children.toArray(_this2.props.children).filter(function (route) {
        return (0, _includes2.default)(_this2.mounted, route.props.name);
      });
      var index = (0, _findIndex2.default)(routes, function (route) {
        return route.props.name === _this2.state.current;
      });
      if (index === -1) {
        index = 0;
      }
      _reactors.Animated.timing(_this2.offsetX, { toValue: -(_this2.props.width * index) }).start();
    }
  };

  this.render = function () {
    return _jsx(_reactors.View, {
      style: [{
        height: _this2.props.height,
        overflow: 'auto',
        position: 'relative',
        width: _this2.props.containerWidth || _this2.props.width,
        boxSizing: 'border-box'
      }, _this2.props.containerStyle]
    }, void 0, _jsx(_reactors.Animated, {
      className: 'reactors-router-animated',
      style: _extends({
        flexDirection: 'row',
        height: _this2.props.height,
        transform: [{ translateX: _this2.offsetX }],
        width: _this2.getFullWidth(),
        boxSizing: 'border-box'
      }, _this2.props.innerContainerStyle)
    }, void 0, _react2.default.Children.toArray(_this2.props.children).map(function (child) {
      return _jsx(_reactors.View, {
        style: [_extends({}, (0, _pick2.default)(_this2.props, ['height', 'width']), {
          boxSizing: 'border-box'
        }), _this2.props.routeStyle]
      }, child.props.name, (0, _includes2.default)(_this2.mounted, child.props.name) && _react2.default.createElement(
        _Route2.default,
        _extends({}, (0, _omit2.default)(child.props, ['children']), {
          width: _this2.props.width,
          style: _this2.props.routeStyle
        }),
        child.props.children
      ));
    })));
  };

  this.offsetX = new _reactors.Animated.Value(0);

  this.getCurrentRoute = function () {
    return _this2.state.current;
  };

  this.getHeight = function () {
    return _this2.props.height;
  };

  this.getWidth = function () {
    return _this2.props.width;
  };

  this.getFullWidth = function () {
    return _this2.props.width * (0, _compact2.default)(_this2.mounted).length;
  };

  this.go = function (routeName, cb) {
    if (!(0, _includes2.default)(_this2.mounted, routeName)) {
      _this2.mounted.push(routeName);
    }
    _this2.setState({ current: routeName }, cb);
  };

  this.hasRoute = function (routeName) {
    return _this2.state.routes.some(function (route) {
      return route.props.name === routeName;
    });
  };
};

exports.default = ReactorsRouter;